#!/usr/bin/python

# Copyright (C) 2013 Koichi Akabe <vbkaisetsui@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#

FONTFORGE = "/usr/bin/fontforge"

import sys, os, glob

if sys.version_info[0] < 3:
	import codecs

if len(sys.argv) != 4:
	print("Glyph stripper")
	print("  usage: python strip_unused.py [orig_font] [dest_font] [script_dir]")
	sys.exit()

charlst = []
stripper = os.path.join(os.path.dirname(__file__), "strip_glyphs.pe")
scriptfiles = glob.glob(os.path.join(sys.argv[3], "*.rpy"))
cmdline = [FONTFORGE, "-script", stripper, sys.argv[1], sys.argv[2], "u0000:u00FF"]

for fname in scriptfiles:
	if sys.version_info[0] >= 3:
		f = open(fname, "r")
	else:
		f = codecs.open(fname, "r", "utf-8")
	for l in f:
		for c in l[:-1]:
			code = ord(c)
			if code > 255 and not code in charlst:
				charlst.append(code)
	f.close()

charlst.sort()
for c in charlst:
	cmdline.append("u%04x" % c)

import subprocess
subprocess.call(cmdline)
